﻿Imports System.Web.Http.SelfHost
Imports System.Web.Http

Module Module1
    Sub Main()
        Dim config As New HttpSelfHostConfiguration("http://127.0.0.1:21212")

        config.Routes.MapHttpRoute( _
            name:="DefaultApi", _
            routeTemplate:="api/{controller}/{id}", _
            defaults:=New With {.id = RouteParameter.Optional} _
        )

        Using server As New HttpSelfHostServer(config)
            Try
                server.OpenAsync().Wait()
                Console.WriteLine("Listening.")
            Catch aggEx As AggregateException
                Console.WriteLine("Error opening server.")
                Console.WriteLine()
                Console.WriteLine("This error usually means that either this application or Visual Studio itself ")
                Console.WriteLine("is not running with elevated permissions.")
                Console.WriteLine()
                Console.WriteLine("Try running Visual Studio as Administrator by right-clicking on the ")
                Console.WriteLine("Visual Studio icon, and selecting ""Run as Administrator""")
                Console.WriteLine()
                Console.WriteLine("Another work around is to open a command prompt as administrator and type:")
                Console.WriteLine("netsh http add urlacl url=http://+:21212/ user=machine\username")
                Console.WriteLine("replacing machine\username with your machine name, and user name.")
            End Try

            Console.WriteLine()
            Console.WriteLine("Press enter to stop listening and exit.")
            Console.ReadLine()
        End Using

    End Sub
End Module
